package org.openxma.dsl.generator.impl

import org.openxma.dsl.core.model.DataTypeAndTypeParameter

import static extension org.openxma.dsl.generator.lib.ValidatorExtensions.*

import static org.openxma.dsl.generator.helper.GeneratorConfigurationExtension.*
import org.openxma.dsl.pom.model.Table
import com.google.inject.Inject
import org.openxma.dsl.pom.model.Tree
import org.openxma.dsl.pom.model.CustomizeableField
import org.openxma.dsl.pom.model.Combo
import org.openxma.dsl.pom.model.ListBox
import org.openxma.dsl.pom.model.TableCombo
class FaceletDataImpl {
	
	@Inject
	extension JsfNames jsfNames
	@Inject
	extension JsfData jsfData
	
	def CharSequence createConverter(DataTypeAndTypeParameter it) {
		if (validatorReferenceDefinition == null) {
			''''''
		}
		else if (validatorReferenceDefinition.dateValidator) {
			'''<f:convertDateTime pattern="dd.MM.yyyy" />'''
		}
		else if (validatorReferenceDefinition.numberValidator) { 
			'''<f:convertNumber minFractionDigits="getScale()" maxFractionDigits="getScale()" />''' 
		}
		else if (validatorReferenceDefinition.i18nValidator) {
			'''<ui:remove>i18n should be displayed as combo, no converter needed</ui:remove>'''
		}
		else {
			''''''
		}
	}
	
	
	def CharSequence getListProperty(TableCombo tableCombo) {
		'''tableCombo.object.eContainer.referencedBean.tableCombo.object.name'''
	}
	def CharSequence getModelProperty(Table table) {
		'''table.parentPage.bean.table.modelPropertyName'''
	}
	def CharSequence getRootNodeProperty(Tree tree) {
		'''tree.parentPage.bean.tree.rootNodePropertyName'''
	}
	def CharSequence getSelectedNodeProperty(Tree tree) {
		'''tree.parentPage.bean.tree.selectedNodePropertyName'''
	}
	def CharSequence getSelectItemsProperty(CustomizeableField field) {
		'''field.parentPage.bean.field.selectItemsPropertyName'''
	}
	def CharSequence getSelectItemsProperty(Combo combo) {
		'''combo.parentPage.bean.combo.selectItemsPropertyName'''
	}
	def CharSequence getSelectItemsProperty(ListBox listbox) {
		'''listbox.parentPage.bean.listbox.selectItemsPropertyName'''
	}
	def CharSequence getSelectItemsProperty(TableCombo combo) {
		'''combo.parentPage.bean.combo.selectItemsPropertyName'''
	}
}