package org.openxma.dsl.generator.impl

import javax.inject.Inject
import org.openxma.dsl.pom.model.XmadslPage
import org.eclipse.emf.ecore.EObject
import org.openxma.dsl.pom.model.Component

class FilesImpl implements Files {
	String BACKING_BEAN_FOLDER = "backingbean"
	
    @Inject
    extension Types types
    
    override packageFolderPath(EObject eObject) {
        eObject.model?.name.replaceAll("\\.","/")
    }
    
    override faceletPageFileName(XmadslPage page, boolean generated) {
        "pages/"+(page.eContainer as Component).xmaComponent.namClass + "/"+page.name.toFirstLower()+ (if (generated)  ".gen" else "")+".xhtml"
    }
    
    def dispatch backingBeanFileName(XmadslPage page, boolean generated) {
        page.packageFolderPath+"/"+BACKING_BEAN_FOLDER+"/"+page.name+ (if (generated)  "Gen" else "")+".java"
    }
    
    def dispatch backingBeanFileName(Component comp, boolean generated) {
        comp.packageFolderPath+"/"+BACKING_BEAN_FOLDER+"/"+comp.xmaComponent.namClass+ (if (generated)  "Gen" else "")+".java"
    }
    
    override toJavaFilePath(String qualifiedName) {
        qualifiedName.toFilePath("java")
    }
     
    override toFilePath(String qualifiedName, String fileExtension) {
        qualifiedName.replaceAll("\\.","/")+"."+fileExtension
    }

	override String toResourceBundleFilePath(Component comp) {
		comp.xmaComponent.namPackageAsPath + "/" + comp.xmaComponent.namClass + ".properties"
	}
}