package org.openxma.dsl.generator.impl

import com.google.inject.Inject
import com.google.inject.Singleton
import org.openxma.dsl.pom.model.XmadslPage
import org.openxma.dsl.pom.model.EventMappingList
import org.openxma.dsl.pom.model.EnterEventMapping
import org.openxma.dsl.pom.model.LeaveEventMapping
import org.openxma.dsl.pom.model.InitEventMapping

@Singleton
class JsfEventsImpl implements JsfEvents {
	@Inject
	extension Names names
	

	override CharSequence toLifecycleMethods(XmadslPage it) { '''
	@addImport("javax.annotation.PostConstruct")
	public void beanInit() {
		dataModelInit();
		onInit();
		onEnter();
	}
	
	public void invoke() {
		onInit();
		onEnter();
	}
	'''
	}
	override CharSequence toLifecycleMethods(EventMappingList it) {
	'''
	/**
	 * PML onLoad event
	 */
	protected void onEnter() {
        FOR mapping : mapping.filter(typeof(EnterEventMapping))
        FOR function : mapping.eventFunctions
        IF !function.command.clientOnly
        function.command.name();
        ENDIF    
        ENDFOR
        ENDFOR    
	}
	
	/**
	 * PML onLeave event
	 */
	protected void onLeave() {
        FOR mapping : mapping.filter(typeof(LeaveEventMapping))
        FOR function : mapping.eventFunctions
        IF !function.command.clientOnly
        function.command.name();
        ENDIF    
        ENDFOR    
        ENDFOR    
	}
	
	/**
	 * PML onInit event
	 */
	protected void onInit() {
        FOR mapping : mapping.filter(typeof(InitEventMapping))
        FOR function : mapping.eventFunctions
        IF !function.command.clientOnly
        function.command.name();
        ENDIF    
        ENDFOR    
        ENDFOR 
	}
	'''

	}
	
	
	
}