package org.openxma.dsl.generator.impl

import org.eclipse.emf.ecore.EObject
import org.openxma.dsl.core.model.Model
import org.openxma.dsl.core.model.Type
import org.openxma.dsl.dom.model.Entity
import org.openxma.dsl.dom.model.Attribute
import org.openxma.dsl.dom.model.DataView
import org.openxma.dsl.dom.model.ValueObject
import org.openxma.dsl.dom.model.PresentableFeature

class TypesImpl implements Types {
	
	def dispatch Type parentType(Attribute att) {
		switch att.eContainer {
			ValueObject : {
				att.eContainer as ValueObject
			}
			DataView : {
				att.eContainer as DataView
			}
			Entity : {
				(att.eContainer as Entity).pomType
			}
			default : null
		} 
	}
	def dispatch Type parentType(PresentableFeature feature) {
		switch feature.eContainer {
			ValueObject : {
				feature.eContainer as ValueObject
			}
			DataView : {
				feature.eContainer as DataView
			}
			Entity : {
				(feature.eContainer as Entity).pomType
			}
			default : null
		} 
	}
	
	override pomType(Type type) {
		switch type {
			Entity : {
				type.defaultDataView
			}
			default : type
		}
	}
    
    override Model model(EObject eObject) {
        var result = eObject
    	while (!(result instanceof Model) && result.eContainer != null) {
    		result = result.eContainer
    	}
        result as Model
    }
}